"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var events_1 = require("events");
var cli_1 = require("../cli");
var command_1 = require("../command");
var Bashme = /** @class */ (function (_super) {
    __extends(Bashme, _super);
    function Bashme(options) {
        var _this = _super.call(this) || this;
        _this.options = {
            debugMode: false,
            prompt: 'bashme$ ',
            welcomeMessage: ''
        };
        if (options) {
            Object.assign(_this.options, options);
        }
        _this.cli = new cli_1.Cli({
            prompt: _this.options.prompt,
            welcomeMessage: _this.options.welcomeMessage
        });
        _this.cli.on('input', function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return _this.emit.apply(_this, ['input'].concat(args));
        });
        _this.cli.register(new command_1.ClearCommand(_this.cli));
        _this.cli.register(new command_1.HelpCommand(_this.cli));
        if (_this.options.debugMode) {
            _this.cli.register(new command_1.DebugCommand());
        }
        return _this;
    }
    Bashme.prototype.use = function (commandProvider) {
        var _this = this;
        commandProvider.getCommands().forEach(function (command) { return _this.cli.register(command); });
        return this;
    };
    Bashme.prototype.show = function (domElement) {
        this.cli.show(domElement);
    };
    return Bashme;
}(events_1.EventEmitter));
exports.Bashme = Bashme;
//# sourceMappingURL=index.js.map