/// <reference types="node" />
import { EventEmitter } from 'events';
import { TCommand } from '../command/types';
export interface CliOptions {
    prompt?: string;
    welcomeMessage?: string;
}
export declare class Cli extends EventEmitter {
    private commands;
    private helpTopics;
    private buffer;
    private commandRunning;
    private cursorOffset;
    private options;
    private terminal;
    private terminalHistory;
    private terminalHistoryIndex;
    constructor(options?: CliOptions);
    private input;
    private processInput;
    private processCommand;
    private processCommandOutput;
    private processCommandOutputAsTable;
    private prompt;
    clear(): void;
    help(): void;
    helpTopic(cmdName: string): void;
    register(command: TCommand): void;
    show(domElement: HTMLElement): void;
    write(str: string): void;
}
