"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var cli_table2_1 = __importDefault(require("cli-table2"));
var easy_table_1 = __importDefault(require("easy-table"));
var events_1 = require("events");
var minimist = __importStar(require("minimist"));
var xterm_1 = require("xterm");
var fit_1 = require("xterm/lib/addons/fit/fit");
var webLinks_1 = require("xterm/lib/addons/webLinks/webLinks");
var types_1 = require("../command/types");
var EOL = '\r\n';
var Cli = /** @class */ (function (_super) {
    __extends(Cli, _super);
    function Cli(options) {
        var _this = _super.call(this) || this;
        _this.commands = {};
        _this.helpTopics = {};
        _this.buffer = '';
        _this.commandRunning = false;
        _this.cursorOffset = 0;
        _this.options = { prompt: '> ' };
        _this.terminalHistory = [];
        _this.terminalHistoryIndex = 0;
        if (options) {
            Object.assign(_this.options, options);
        }
        _this.terminal = new xterm_1.Terminal({
            convertEol: true,
            cursorBlink: true,
            cursorStyle: 'underline',
            fontFamily: 'Menlo, "DejaVu Sans Mono", Consolas, "Lucida Console", monospace',
            fontSize: 12
        });
        _this.terminal.on('key', function (d) { return _this.input(d); });
        _this.terminal.on('paste', function (d) { return _this.input(d); });
        return _this;
    }
    Cli.prototype.input = function (str) {
        switch (str.charCodeAt(0)) {
            case 8: // backspace
                if (this.cursorOffset === 0)
                    break;
                this.cursorOffset--;
                this.buffer = this.buffer.substr(0, this.cursorOffset) + this.buffer.substr(this.cursorOffset + 1);
                this.terminal.write('\b \b');
                break;
            case 127: // del
                if (this.cursorOffset === 0)
                    break;
                // TODO: change it so it works outside browser too
                console.log(navigator.platform.indexOf('Mac'));
                if (navigator.platform.indexOf('Mac') >= 0) {
                    this.cursorOffset--;
                    this.buffer = this.buffer.substr(0, this.cursorOffset) + this.buffer.substr(this.cursorOffset + 1);
                    this.terminal.write('\b \b');
                }
                break;
            case 13: // enter
                this.terminal.write(EOL);
                this.processInput();
                break;
            case 27:
                if (str.charCodeAt(1) === 91 && str.charCodeAt(2) === 65) { // up
                    var cmd = this.terminalHistory[this.terminalHistoryIndex - 1];
                    if (cmd) {
                        this.terminalHistoryIndex--;
                        this.terminal.write(Array(this.buffer.length + 1).join('\b \b'));
                        this.terminal.write(cmd);
                        this.cursorOffset = cmd.length;
                        this.buffer = cmd;
                    }
                }
                else if (str.charCodeAt(1) === 91 && str.charCodeAt(2) === 66) { // down
                    var cmd = this.terminalHistory[this.terminalHistoryIndex + 1];
                    if (cmd) {
                        this.terminalHistoryIndex++;
                        this.terminal.write(Array(this.buffer.length + 1).join('\b \b'));
                        this.terminal.write(cmd);
                        this.cursorOffset = cmd.length;
                        this.buffer = cmd;
                    }
                }
                else if (str.charCodeAt(1) === 91 && str.charCodeAt(2) === 67) { // right
                    if (this.cursorOffset === this.terminal.cols)
                        break;
                    this.cursorOffset++;
                    this.terminal.write(str);
                }
                else if (str.charCodeAt(2) === 68) { // left
                    if (this.cursorOffset === 0)
                        break;
                    this.cursorOffset--;
                    this.terminal.write(str);
                }
                break;
            default:
                var rest = this.buffer.substr(this.cursorOffset);
                this.buffer = this.buffer.substr(0, this.cursorOffset) + str + rest;
                this.cursorOffset++;
                this.terminal.write(str + rest + Array(rest.length + 1).join('\b'));
                break;
        }
    };
    Cli.prototype.processInput = function () {
        var _this = this;
        if (this.commandRunning)
            return;
        var buffer = this.buffer.trim();
        if (buffer) {
            this.emit('input', buffer);
            var args = minimist.default(buffer.split(' '));
            var argsQueue = args._.slice(0);
            var command = undefined;
            var commands = this.commands;
            while (argsQueue.length) {
                var arg = argsQueue.shift();
                if (!arg)
                    break;
                if (!commands[arg])
                    break;
                command = commands[arg];
                // @ts-ignore
                commands = command.subCommands;
                if (!commands)
                    break;
            }
            if (command !== undefined) {
                this.commandRunning = true;
                this.processCommand(command, __assign({}, args, { _: argsQueue }))
                    .catch(function (err) {
                    console.log(err);
                    _this.commandRunning = false;
                    _this.write("ERR! " + _this.processCommandOutput(err) + EOL);
                    _this.prompt();
                })
                    .then(function (output) {
                    _this.commandRunning = false;
                    _this.write("" + _this.processCommandOutput(output));
                    if (buffer !== 'clear')
                        _this.write(EOL);
                    _this.prompt();
                });
            }
            else {
                this.write(args._[0] + ": command not found" + EOL);
            }
            this.terminalHistory.push(buffer);
            this.terminalHistoryIndex = this.terminalHistory.length;
        }
        this.cursorOffset = 0;
        this.buffer = '';
        if (!this.commandRunning) {
            this.prompt();
        }
    };
    Cli.prototype.processCommand = function (command, args) {
        if (command instanceof types_1.AsyncCommand) {
            return command.run(args);
        }
        else {
            return Promise.resolve(command.run(args));
        }
    };
    Cli.prototype.processCommandOutput = function (output) {
        if (typeof output === 'object') {
            if (Array.isArray(output)) {
                // print as table
                return this.processCommandOutputAsTable(output);
            }
            else {
                // print as json
                return JSON.stringify(output, null, 2);
            }
        }
        else {
            var o = output;
            return o || '';
        }
    };
    Cli.prototype.processCommandOutputAsTable = function (output) {
        if (!output.length)
            return '';
        // try to estimate the maximun row width 
        var estimatedMaxRowWidth = 0;
        var strlen = function (o) { return ('' + o).length; };
        try {
            output.forEach(function (item) {
                var estimatedRowWidth = 1;
                for (var k in item) {
                    estimatedRowWidth += strlen(item[k]) + 3;
                }
                if (estimatedRowWidth > estimatedMaxRowWidth) {
                    estimatedMaxRowWidth = estimatedRowWidth;
                }
            });
        }
        catch (err) {
        }
        var colWidths = [];
        // if it's needed calculate the last column's width so the entire table fits in the terminal 
        if (estimatedMaxRowWidth > this.terminal.cols) {
            var cols = Object.keys(output[0]).length;
            colWidths = Array(cols).fill(Math.floor(this.terminal.cols / cols - 1));
            colWidths[cols - 1] += this.terminal.cols % cols - 1;
        }
        var table = new cli_table2_1.default({
            chars: {
                'top': ' ', 'top-mid': ' ', 'top-left': ' ', 'top-right': ' ',
                'bottom': ' ', 'bottom-mid': ' ', 'bottom-left': ' ', 'bottom-right': ' ',
                'mid': '-', 'mid-mid': '|', 'middle': '|',
                'left': ' ', 'left-mid': ' ',
                'right': ' ', 'right-mid': ' '
            },
            colWidths: colWidths,
            head: Object.keys(output[0]),
            wordWrap: true,
        });
        output.forEach(function (item) {
            // @ts-ignore
            table.push(Object.values(item));
        });
        return table.toString();
    };
    Cli.prototype.prompt = function () {
        this.terminal.write("" + this.options.prompt + this.buffer);
    };
    Cli.prototype.clear = function () {
        this.terminal.reset();
    };
    // TODO: Move to HelpCommand
    Cli.prototype.help = function () {
        var table = new easy_table_1.default();
        table.separator = '\t\t';
        for (var i in this.commands) {
            table.cell('name', this.commands[i].name);
            table.cell('description', this.commands[i].description);
            table.newRow();
        }
        this.terminal.write(EOL + "These commands are defined." + EOL + "Type `help name` to find out more about the function `name`." + EOL + EOL + "\t" + table.print().replace(/\r?\n/g, EOL + "\t"));
    };
    // TODO: Move to HelpCommand
    Cli.prototype.helpTopic = function (cmdName) {
        if (this.helpTopics[cmdName]) {
            this.write("" + EOL + this.helpTopics[cmdName] + EOL);
        }
        else {
            this.write("no help topics match `" + cmdName + "`");
        }
    };
    Cli.prototype.register = function (command) {
        this.commands[command.name] = command;
        if (command.helpTopic) {
            this.helpTopics[command.name] = command.helpTopic;
        }
    };
    Cli.prototype.show = function (domElement) {
        var _this = this;
        this.terminal.open(domElement);
        this.terminal.focus();
        if (this.options.welcomeMessage && this.options.welcomeMessage.length) {
            this.write("" + this.options.welcomeMessage + EOL + EOL);
        }
        this.prompt();
        fit_1.fit(this.terminal);
        webLinks_1.webLinksInit(this.terminal);
        window.onresize = function () { return fit_1.fit(_this.terminal); };
    };
    Cli.prototype.write = function (str) {
        this.terminal.write(str);
    };
    return Cli;
}(events_1.EventEmitter));
exports.Cli = Cli;
//# sourceMappingURL=index.js.map