"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var helpTopic_1 = require("../helpTopic");
var types_1 = require("./types");
var AwardsCommand = /** @class */ (function (_super) {
    __extends(AwardsCommand, _super);
    function AwardsCommand(awards) {
        var _this = _super.call(this) || this;
        _this.name = 'awards';
        _this.description = 'shows awards';
        _this.awards = awards;
        _this.helpTopic = new helpTopic_1.HelpTopic(_this, {
            synopsis: 'awards [-y]',
            options: {
                '-y': 'List all awards earned in the -y year'
            },
            examples: [
                {
                    cmd: 'awards -y 2018',
                    description: 'The following command shows all awards earned in the 2018 year'
                }
            ]
        });
        return _this;
    }
    AwardsCommand.prototype.run = function (args) {
        var data = this.awards;
        if (args.y) {
            data = data.filter(function (a) { return a.year == args.y; });
        }
        return data;
    };
    return AwardsCommand;
}(types_1.SyncCommand));
exports.AwardsCommand = AwardsCommand;
//# sourceMappingURL=AwardsCommand.js.map