"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var helpTopic_1 = require("../helpTopic");
var types_1 = require("./types");
var EducationCommand = /** @class */ (function (_super) {
    __extends(EducationCommand, _super);
    function EducationCommand(education) {
        var _this = _super.call(this) || this;
        _this.name = 'education';
        _this.description = 'shows education';
        _this.education = education;
        _this.helpTopic = new helpTopic_1.HelpTopic(_this, {
            synopsis: 'education [-y]',
            options: {
                '-y': 'List all entries which contains the -y year between startYear and endYear'
            },
            examples: [
                {
                    cmd: 'education -y 2018',
                    description: 'The following command shows all education entries that happened in the 2018 year'
                }
            ]
        });
        return _this;
    }
    EducationCommand.prototype.run = function (args) {
        var data = this.education;
        if (args.y) {
            data = data.filter(function (e) { return e.startYear <= args.y && e.endYear >= args.y; });
        }
        return data;
    };
    return EducationCommand;
}(types_1.SyncCommand));
exports.EducationCommand = EducationCommand;
//# sourceMappingURL=EducationCommand.js.map