"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var helpTopic_1 = require("../helpTopic");
var types_1 = require("./types");
var LanguagesCommand = /** @class */ (function (_super) {
    __extends(LanguagesCommand, _super);
    function LanguagesCommand(languages) {
        var _this = _super.call(this) || this;
        _this.name = 'languages';
        _this.description = 'shows languages';
        _this.languages = languages;
        _this.helpTopic = new helpTopic_1.HelpTopic(_this, {
            synopsis: 'languages [-l]',
            options: {
                '-l': 'List all languages in which the level is -l'
            },
            examples: [
                {
                    cmd: 'languages -l proficient',
                    description: 'The following command shows all languages in which the level is proficient'
                }
            ]
        });
        return _this;
    }
    LanguagesCommand.prototype.run = function (args) {
        var data = this.languages;
        if (args.l) {
            data = data.filter(function (l) { return l.level === args.l; });
        }
        return data;
    };
    return LanguagesCommand;
}(types_1.SyncCommand));
exports.LanguagesCommand = LanguagesCommand;
//# sourceMappingURL=LanguagesCommand.js.map