"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var helpTopic_1 = require("../helpTopic");
var types_1 = require("./types");
var PublicationsCommand = /** @class */ (function (_super) {
    __extends(PublicationsCommand, _super);
    function PublicationsCommand(publications) {
        var _this = _super.call(this) || this;
        _this.name = 'publications';
        _this.description = 'shows publications';
        _this.publications = publications;
        _this.helpTopic = new helpTopic_1.HelpTopic(_this, {
            synopsis: 'publications [-y]',
            options: {
                '-y': 'List all publications released in the -y year'
            },
            examples: [
                {
                    cmd: 'publications -y 2018',
                    description: 'The following command shows all publications released in the 2018 year'
                }
            ]
        });
        return _this;
    }
    PublicationsCommand.prototype.run = function (args) {
        var data = this.publications;
        if (args.y) {
            data = data.filter(function (p) { return p.releaseYear <= args.y; });
        }
        return data;
    };
    return PublicationsCommand;
}(types_1.SyncCommand));
exports.PublicationsCommand = PublicationsCommand;
//# sourceMappingURL=PublicationsCommand.js.map