"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var helpTopic_1 = require("../helpTopic");
var types_1 = require("./types");
var SkillsCommand = /** @class */ (function (_super) {
    __extends(SkillsCommand, _super);
    function SkillsCommand(skills) {
        var _this = _super.call(this) || this;
        _this.name = 'skills';
        _this.description = 'shows skills';
        _this.skills = skills;
        _this.helpTopic = new helpTopic_1.HelpTopic(_this, {
            synopsis: 'skills [-l]',
            options: {
                '-l': 'List all skills in which the level is -l'
            },
            examples: [
                {
                    cmd: 'skills -l advanced',
                    description: 'The following command shows all skills in which the level is advanced'
                }
            ]
        });
        return _this;
    }
    SkillsCommand.prototype.run = function (args) {
        var data = this.skills;
        if (args.l) {
            data = data.filter(function (s) { return s.level === args.l; });
        }
        return data;
    };
    return SkillsCommand;
}(types_1.SyncCommand));
exports.SkillsCommand = SkillsCommand;
//# sourceMappingURL=SkillsCommand.js.map