"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var helpTopic_1 = require("../helpTopic");
var types_1 = require("./types");
var VolunteerCommand = /** @class */ (function (_super) {
    __extends(VolunteerCommand, _super);
    function VolunteerCommand(volunteer) {
        var _this = _super.call(this) || this;
        _this.name = 'volunteer';
        _this.description = 'shows volunteer experience';
        _this.volunteer = volunteer;
        _this.helpTopic = new helpTopic_1.HelpTopic(_this, {
            synopsis: 'volunteer [--currentYear XOR -y]',
            options: {
                '--currentYear': 'List all volunteer experience in the current year',
                '-y': 'List all volunteer experience in which the year -y is between startYear and endYear',
            },
            examples: [
                {
                    cmd: 'volunteer --currentYear',
                    description: 'The following command shows all volunteer experience that happened in the current year'
                },
                {
                    cmd: 'volunteer -y 2018',
                    description: 'The following command shows all volunteer experience that happened in the 2018 year'
                },
                {
                    cmd: 'volunteer --currentYear -y 2017',
                    description: 'The following command shows all volunteer experience that happened in the current year (Because --currentYear has more precedence than -y)'
                }
            ]
        });
        return _this;
    }
    VolunteerCommand.prototype.run = function (args) {
        var data = this.volunteer;
        if (args.currentYear) {
            var currentYear_1 = new Date().getUTCFullYear() - 1;
            data = data.filter(function (v) { return v.startYear <= currentYear_1 && v.endYear >= currentYear_1; });
        }
        else if (args.y) {
            data = data.filter(function (v) { return v.startYear <= args.y && v.endYear >= args.y; });
        }
        return data;
    };
    return VolunteerCommand;
}(types_1.SyncCommand));
exports.VolunteerCommand = VolunteerCommand;
//# sourceMappingURL=VolunteerCommand.js.map