"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var helpTopic_1 = require("../helpTopic");
var types_1 = require("./types");
var WorkCommand = /** @class */ (function (_super) {
    __extends(WorkCommand, _super);
    function WorkCommand(work) {
        var _this = _super.call(this) || this;
        _this.name = 'work';
        _this.description = 'shows work experience';
        _this.work = work;
        _this.helpTopic = new helpTopic_1.HelpTopic(_this, {
            synopsis: 'work [--current XOR -y]',
            options: {
                '--current': 'List all work experience in the current year',
                '-y': 'List all work experience in which the year -y is between startYear and endYear',
            },
            examples: [
                {
                    cmd: 'work --current',
                    description: 'The following command shows the current work experience'
                },
                {
                    cmd: 'work -y 2018',
                    description: 'The following command shows all the work experience that happened in the 2018 year'
                },
                {
                    cmd: 'work --current -y 2017',
                    description: 'The following command shows the current work experience (Because --current has more precedence than -y)'
                }
            ]
        });
        return _this;
    }
    WorkCommand.prototype.run = function (args) {
        var data = this.work;
        if (args.current) {
            data = data.filter(function (w) { return w.endYear === null; });
        }
        else if (args.y) {
            data = data.filter(function (w) { return w.startYear <= args.y && w.endYear >= args.y; });
        }
        return data;
    };
    return WorkCommand;
}(types_1.SyncCommand));
exports.WorkCommand = WorkCommand;
//# sourceMappingURL=WorkCommand.js.map