import { ParsedArgs } from 'minimist';
import { HelpTopic } from '../../helpTopic';
import { IProperty } from '../../property';
export declare abstract class AsyncCommand {
    abstract name: string;
    abstract description: string;
    helpTopic?: HelpTopic;
    subCommands?: {
        [key: string]: TCommand;
    };
    abstract run(args?: ParsedArgs): Promise<TCommandOutput>;
}
export declare abstract class SyncCommand {
    abstract name: string;
    abstract description: string;
    helpTopic?: HelpTopic;
    subCommands?: {
        [key: string]: TCommand;
    };
    abstract run(args?: ParsedArgs): TCommandOutput;
}
export declare type TCommand = AsyncCommand | SyncCommand;
export declare type TCommandOutput = void | IProperty | Array<IProperty>;
