"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var command_1 = require("../command");
var Json = /** @class */ (function () {
    function Json(object) {
        this.data = object;
    }
    Json.prototype.getCommands = function () {
        var commands = [];
        if (this.data.name) {
            commands.push(new command_1.AnyStringCommand('name', 'shows name', this.data.name));
        }
        if (this.data.bio) {
            commands.push(new command_1.AnyStringCommand('bio', 'shows bio', this.data.bio));
        }
        if (this.data.education && this.data.education.length) {
            commands.push(new command_1.EducationCommand(this.data.education));
        }
        if (this.data.work && this.data.work.length) {
            commands.push(new command_1.WorkCommand(this.data.work));
        }
        if (this.data.volunteer && this.data.volunteer.length) {
            commands.push(new command_1.VolunteerCommand(this.data.volunteer));
        }
        if (this.data.awards && this.data.awards.length) {
            commands.push(new command_1.AwardsCommand(this.data.awards));
        }
        if (this.data.publications && this.data.publications.length) {
            commands.push(new command_1.PublicationsCommand(this.data.publications));
        }
        if (this.data.skills && this.data.skills.length) {
            commands.push(new command_1.SkillsCommand(this.data.skills));
        }
        if (this.data.languages && this.data.languages.length) {
            commands.push(new command_1.LanguagesCommand(this.data.languages));
        }
        return commands;
    };
    return Json;
}());
exports.Json = Json;
//# sourceMappingURL=Json.js.map